  .inesprg 1
  .ineschr 1
  .inesmap 0
  .inesmir 0
  
;;;;;;;;;;;;;;;

  .rsset $0000
pointerLo  .rs 1
pointerHi  .rs 1

;;;;;;;;;;;;;;;
    
  .bank 0
  .org $C000 
RESET:
  SEI
  CLD
  LDX #$40
  STX $4017
  LDX #$FF
  TXS
  INX
  STX $2000
  STX $2001
  STX $4010

vblankwait1:
  BIT $2002
  BPL vblankwait1

clrmem:
  LDA #$00
  STA $0000, x
  STA $0100, x
  STA $0200, x
  STA $0300, x
  STA $0400, x
  STA $0500, x
  STA $0600, x
  STA $0700, x
  LDA #$FE
  STA $0200, x
  INX
  BNE clrmem
   
vblankwait2:
  BIT $2002
  BPL vblankwait2


LoadPalettes:
  LDA $2002
  LDA #$3F
  STA $2006
  LDA #$00
  STA $2006
  LDX #$00
LoadPalettesLoop:
  LDA palette, x
  STA $2007 
  INX
  CPX #$20
  BNE LoadPalettesLoop

;   ,    
LoadSprites:
  LDX #$00
LoadSpritesLoop:
  LDA sprites, x
  STA $0200, x
  INX
  CPX #$00
  BNE LoadSpritesLoop
  
LoadBackground:
  LDA $2002
  LDA #$20
  STA $2006
  LDA #$00
  STA $2006

  LDA #$00
  STA pointerLo
  LDA #HIGH(background)
  STA pointerHi
  
  LDX #$00
  LDY #$00
OutsideLoop:
  
InsideLoop:
  LDA [pointerLo], y
  STA $2007
  
  INY
  CPY #$00
  BNE InsideLoop
  
  INC pointerHi
  
  INX
  CPX #$04
  BNE OutsideLoop              
              
;  LDA #%10010000   ;    ,  -  .
  LDA #%10000000   ;      
  STA $2000
  LDA #%00011110   ; enable sprites, enable background, no clipping on left side
  STA $2001

Forever:
  JMP Forever
  
 

NMI:
  LDA #$00
  STA $2003
  LDA #$02
  STA $4014
  LDA #$00        ;;tell the ppu there is no background scrolling
  STA $2005
  STA $2005
  

  RTI
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;		   		;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
  .bank 1
  .org $E000
background:
  .incbin "nametable.nam"

attributes:
  .incbin "nametable.nam"

palette:
  .incbin "pal-bg.pal"
  .incbin "pal-sprites.pal"

sprites:
;     vert tile attr horiz
  .db $76, $93, $00, $5A ;  1
  .db $73, $92, $00, $66 ;  2
  .db $AD, $94, $0A, $A8 ; 
  .db $9E, $8B, $0A, $B0 ;  1
  .db $9E, $8B, $0A, $B8 ;  2
  .db $9E, $8C, $0A, $C0 ;  3
  .db $96, $99, $05, $30 ;  1
  .db $96, $9A, $05, $38 ;  2
  .db $96, $9B, $05, $40 ;  3
  .db $CA, $95, $00, $27 ;    1
  .db $CA, $96, $00, $2F ;    2
  .db $D2, $A5, $00, $27 ; 
  .db $D2, $A6, $00, $2F ; 
  .db $BB, $97, $0A, $5F ;    1
  .db $BB, $98, $0A, $67 ;    2
  .db $C3, $B2, $00, $5F ; 
  .db $C3, $B3, $00, $67 ; 
  .db $BF, $95, $0F, $A1 ;    1
  .db $BF, $96, $0F, $A9 ;    2
  .db $C7, $A5, $00, $A1 ; 
  .db $C7, $A6, $00, $A9 ; 
  .db $C8, $A2, $0A, $D7 ;   2  1
  .db $C8, $A3, $0A, $DF ;   2  2
  .db $D0, $B2, $00, $D7 ; 
  .db $D0, $B3, $00, $DF ; 
  .db $13, $9C, $05, $09 ;  1
  .db $18, $9C, $05, $A0 ;  1 
  
  .db $20, $A7, $05, $0F ;  2
  .db $20, $A8, $05, $17
  .db $20, $A9, $05, $1F
  
  .db $0F, $A7, $05, $28 ;  2
  .db $0F, $A8, $05, $30
  .db $0F, $A9, $05, $38  
  
  .db $18, $B4, $05, $48 ;  3
  .db $18, $B5, $05, $50
  .db $18, $B6, $05, $58  
  .db $18, $B7, $05, $60 
  
  .db $14, $B8, $05, $70 ;  4
  .db $14, $B9, $05, $78
  .db $14, $BA, $05, $80    
  
  
  
  
  
  
  
  
  
  

  
  .org $FFFA
  .dw NMI
  .dw RESET
  .dw 0
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;						;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
  .bank 2
  .org $0000
  .incbin "tileset.chr"